#include "ygWorld.h"
#include "Spinner.h"

extern "C" ygNode* construct_Spinner(const char* name,bool master) { return new Spinner(name,master); }


Spinner::Spinner(const char* name,bool master) : ygTransform(name,master)
	{
	setClassName("Spinner");
	reset();
	}


void Spinner::reset(void)
	{
	period_ = 1;
	ygTransform::reset();
	}


void Spinner::message(const ygMessage& msg)
	{
	if (msg == "period")
		setPeriod(msg.floatArg(0));
	else
		ygTransform::message(msg);
	}


void Spinner::setPeriod(float p)
	{
	if (fabs(p) > 0.0001f)
		period_ = p;
	else
		period_ = 1;
	}


void Spinner::app(void)
	{
	float angle = ygWorld::FrameTime/period_ * 360.0f;
	setOrientation(0, 0, angle);
	ygTransform::app();
	}
