#include <Performer/pfdu.h>
#include <Performer/pf/pfLOD.h>
#include <Performer/pr/pfGeoSet.h>
#include "ygPFObjectCache.h"
#include "lodObject.h"

extern "C" ygNode* construct_lodObject(const char* name,bool master) { return new lodObject(name,master); }

using namespace std;

struct _lodObjectPrivateData
	{
//	bool myDebug;
	};


lodObject::lodObject(const char* name,bool master) : ygObject(name,master)
	{
	setClassName("lodObject");
	p_ = new struct _lodObjectPrivateData;
//	debugFlag("myDebug", &p_->myDebug);

	range_ = 40.0f;
	count_ = 0;
	viewable_ = 1000.0f;
	
	lod_ = new pfLOD;
	lod_->setRange (count_, 0.0f);
	pfnode ()->addChild (lod_);
	}

lodObject::~lodObject(void)
	{
	delete p_;
	}


void lodObject::reset(void)
	{
	while (lod_->getNumChildren())
	    lod_->removeChild(lod_->getChild(0));
	    
	ygObject::reset();
	}


void lodObject::message(const ygMessage& msg)
	{
	if (msg == "file")
	{
	    pfNode *obj;
	    
	    obj = ygPFObjectCache::objectReference (msg.args[0]);
	    if (obj)
	    {
		lod_->addChild (obj);
		count_++;
		lod_->setRange (count_, range_);
		lod_->setTransition (count_, 10.0f);
		initializeLOD();
	    }
	}
	
	else if (msg == "range")
		range_ = msg.floatArg(0);
		
	else if (msg == "viewable")
	{
		viewable_ = msg.floatArg(0);
		initializeLOD();
	}
	else
		ygObject::message(msg);
	}

void lodObject::initializeLOD(void)
	{
	    // get the LOD's extents
	    pfSphere bsph;
	
	    lod_->getBound (&bsph);
	    lod_->setCenter (bsph.center);
	
	    // last range determines how far you can
	    // get from the object and still see it.
	    lod_->setRange (count_, viewable_);
	
	}



