#include "mySpinner.h"

using namespace std;

extern "C" ygNode* construct_mySpinner(const char* name,bool master) { return new mySpinner(name,master); }




mySpinner::mySpinner(const char* name,bool master) : ygTransform(name,master)
	{
	setClassName("mySpinner");
	
	 axis_.set(0,0,1);
	 spinTime_ = 1;
	 active_ = false;
	 initActive_ = false;
	 angle_ = 0;
	 startAngle_ = 0;
	 startTime_ = 0;
	
//	debugFlag("myDebug", &p_->myDebug);
	}

mySpinner::~mySpinner(void)
	{
	
	}


void mySpinner::reset(void)
	{
	stop();
	angle_ = 0;
	startAngle_ = 0;
	if (initActive_)
	    start();
	
	ygTransform::reset();
	}


void mySpinner::message(const ygMessage& msg)
	{
	if (msg == "axis")
		msg.getVec3Args(axis_);
	else if (msg == "period")	
		spinTime_ = msg.floatArg(0);
	else if (msg == "active")
		initActive_ = msg.boolArg(0);
	else if (msg == "start")
		start();
	else if (msg == "stop")
		stop();
		
	else
		ygTransform::message(msg);
	}

void mySpinner::start(void)
{
 if (!active_)
	{
	active_ = 1;
	startTime_ = pfGetTime();
	startAngle_ = angle_;
	}
}


void mySpinner::stop(void)
{
 active_ = 0;
}


void mySpinner::app(void)
	{
//	if (p_->myDebug) doMyDebugging();

	if (active_)
		{
		if(spinTime_ != 0)
			{
			pfMatrix rotmat;
			angle_ = startAngle_ + (pfGetTime()-startTime_)/spinTime_*360.0;
			rotmat.makeRot(angle_, axis_[0], axis_[1], axis_[2]);
			setMatrix(rotmat);
			}
		}
	ygTransform::app();
	}
