#include <ygNetKeys.h>
#include "soundNode.h"

extern "C" ygNode* construct_soundNode(const char* name,bool master) { return new soundNode(name,master); }
using namespace std;


soundNode::soundNode(const char* name,bool master) : ygNode(name,master)
	{
	setClassName("soundNode",true);
	addNetKey("lang", &netLanguages_, YG_NET_STRING);
	addNetKey("file", &netFiles_, YG_NET_STRING);
	}


void soundNode::reset(void)
	{
	netLanguages_.clear();
	netKeyChanged("lang");
	netFiles_.clear();
	netKeyChanged("file");
	ygNode::reset();
	}

//eg soundNode hallo (sound(english, hallo.aiff)
void soundNode::message(const ygMessage& msg)
	{
	if (msg == "sound")
	{
	   language_.push_back(msg.args[0]);
	   soundFile_.push_back (msg.args[1]);
	   if (isNetMaster())
		{
		netLanguages_ += " ";
		netLanguages_ += msg.args[0];
		netKeyChanged("lang");
		netFiles_ += " ";
		netFiles_ += msg.args[1];
		netKeyChanged("file");
		}
	}
		
	else
		ygNode::message(msg);
	}

/* returns the correct file to audiotool*/


	
bool soundNode::soundFile(const ygString & language,  ygString & file)
	{
	   for(int i = 0; i < language_.size() ; i++)
	   //search for matching language
	    //return appropriate soundfile
	       if(language_[i]==language)
	       {
		   file = soundFile_[i];
		   eventOccurred("used");
		   return true;
	       }
	       cout << "couldn't find sound for " << language << endl;
	    return false;
	}


void soundNode::acceptNetKey(const ygString& key)
	{
	if (key == "lang")
		{
		ygString * str;
		int i=0;
		language_.clear();
		while (str = netLanguages_.nextToken(" ",&i))
			{
			language_.push_back(*str);
			delete str;
			}
		}
	else if (key == "file")
		{
		ygString * str;
		int i=0;
		soundFile_.clear();
		while (str = netFiles_.nextToken(" ",&i))
			{
			soundFile_.push_back(*str);
			delete str;
			}
		}
	else
		ygNode::acceptNetKey(key);
	}
