#include "ygWorld.h"
#include "timerNode.h"

extern "C" ygNode * construct_timerNode(const char* name,bool master) { return new timerNode(name,master); }


timerNode::timerNode(const char* name,bool master) : dummyNode(name,master)
	{
	setClassName("timerNode");
	reset();
	}


void timerNode::reset(void)
	{
	time_ = 1;
	lastTime_ = ygWorld::FrameTime;
	dummyNode::reset();
	}


void timerNode::message(const ygMessage& msg)
	{
	if (msg == "time")
		time_ = msg.floatArg(0);
	else if (msg == "start")
		lastTime_ = ygWorld::FrameTime;
	else
		dummyNode::message(msg);
	}


void timerNode::app(void)
	{
	float t = ygWorld::FrameTime;
	if (t - lastTime_ >= time_)
		{
		eventOccurred("time");
		lastTime_ = t;
		}
	dummyNode::app();
	}

