#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include <CAVERN.hxx>
#include "ygServerRoot.h"

void * serverLoop(void*);


main(int argc, char **argv)
	{
	CAVERNinit();
	CAVERNts_thread_c serverThread;
	serverThread.create(serverLoop,0);
	sleep(2);
	ygServerRoot::initialize();
	while (true)
		{
		ygServerRoot::update();
		usleep(1000);
		}
	}


void * serverLoop(void*)
	{
	int port=3500;
	int prevTime=time(NULL), nowTime;
	bool showStats = false;
	if (getenv("YG_NET_PORT"))
		port = atoi(getenv("YG_NET_PORT"));
	if (getenv("YG_CAVERN_SHOWSTATS"))
		showStats = true;
	CAVERNdb_server_c server;
	if (server.init("ygdb",port,256,port) != CAVERNdb_server_c::OK)
		return 0;
	while (true)
		{
		server.process();
		if (showStats)
			{
			nowTime = time(NULL);
			if (nowTime - prevTime >= 10)
				{
				server.showStats("CAVERNdb_server","");
				prevTime = nowTime;
				}
			}
//		usleep(1000);
		}
	return 0;
	}
