#include <stdio.h>
#include <iostream>
#include <stack>
#include "ygNode.h"
#include "ygTokenStream.h"

using namespace std;


void parseNode(const ygString& nodeType,ygTokenStream *input,int depth);
void parseInitMessages(ygString& msgList);


main(int argc,char **argv)
        {
        ygString file;
        ygTokenStream *input;
        ygString token;
        int parentStack=0;
        if (argc < 2)
                return -1;
        file = argv[1];
        input = new ygTokenStream(file);
        while (input->next(token))
                {
                if (token == "{")
                        {
                        parentStack++;
                        }
                else if (token == "}")
                        {
                        if (parentStack > 0)
                                {
                                parentStack--;
                                }
                        }
                else if (token[0] == '(')
                        {
                        cerr << "ERROR: parsing " << input->filename()
                                << ", line " << input->linenumber()
                                << ": there's no node for this option list:"
                                << endl << "\t" << token << endl;
                        }
                else
                        {
                        parseNode(token,input,parentStack);
                        }
                }
        delete input;
        }


void parseNode(const ygString& nodeType,ygTokenStream *input,int depth)
        {
        bool gotToken=true;
        ygString token, name;
        gotToken = input->next(token);
        if ((gotToken) && (token[0] != '(') && (token[0] != '{') &&
            (token[0] != '}'))
                {
                name = token;
                gotToken = input->next(token);
                }
        else
                ygNode::createDummyName(name);
        for (int i=0; i< depth; i++)
                cout << "\t";
        cout << nodeType << " " << name << endl;
        if (gotToken)
                {
                if (token[0] == '(')
                        {
                        parseInitMessages(token);
                        }
                else
                        input->pushback(token);
                }
        }


void parseInitMessages(ygString& msgList)
        {
        ygString msg;
        int index=1;
        if (msgList[msgList.length()-1] != ')')
                        msgList += ')';
        while (1)
                {
                msg.clear();
                while ((msgList[index] == ' ') || (msgList[index] == '\t'))
                        index++;
                if (msgList[index] != ')')
                        {
                        int parenDepth=0, quoting=0;
                        while ((parenDepth) || (quoting) ||
                                ((msgList[index] != ',') &&
                                 (msgList[index] != ')')))
                                {
                                if (msgList[index] == '\\')
                                        {
                                        if (quoting)
                                                msg += msgList[index];
                                        index++;
                                        }
                                else if (msgList[index] == '"')
                                        quoting = !quoting;
                                else if ((!quoting) && (msgList[index] == '('))
                                        parenDepth++;
                                else if ((!quoting) && (msgList[index] == ')'))
                                        parenDepth--;
                                msg += msgList[index];
                                index++;
                                }
                        if (msgList[index] == ',')
                                index++;
                        }
                else
                        break;
                }
        }
