#ifndef _xptTokenStream_h_
#define _xptTokenStream_h_

#include <stdio.h>
#include <stack>
#include "ygString.h"

class xptTokenStream
	{
	public:
	 xptTokenStream(const ygString&,FILE*);
	 ~xptTokenStream(void);
	 bool next(ygString &string,bool printWhitespace=true);
	 const ygString& filename(void) const { return filename_; }
	 int linenumber(void) const { return lineNumber_; }
	 void pushback(const ygString& string);
	private:
	 bool getNextLine(bool);
	 bool readNextToken(ygString& token,bool);
	 int nextChar(bool);
	 void pushbackChar(int c);
	 ygString filename_;
	 FILE *fp_;
	 char linebuf_[1024];
	 char *linebufptr_;
	 int lineNumber_;
	 std::stack<ygString*> tokenStack_;
	 std::stack<int> charStack_;
	 FILE *outfp_;
	 ygString prevComment_;
	};

#endif
