#include <pfcave.h>
#include "ygCAVETracker.h"

extern "C" ygNode* construct_ygCAVETracker(const char* name,bool master) { return new ygCAVETracker(name,master); }


ygCAVETracker::ygCAVETracker(const char* name,bool master) : ygSimpleTransform(name,master)
	{
	setClassName("ygCAVETracker");
	sensor_ = 0;
	}


void ygCAVETracker::reset(void)
	{
	ygSimpleTransform::reset();
	}


void ygCAVETracker::message(const ygMessage& msg)
	{
	if (msg == "sensor")
		setSensor(msg.intArg(0));
	else
		ygSimpleTransform::message(msg);
	}


void ygCAVETracker::app(void)
	{
	pfVec3 pos, ori;
	CAVEGetSensorPosition(CAVESENSOR(sensor_), CAVE_TRACKER_FRAME, pos.vec);
	CAVEGetSensorOrientation(CAVESENSOR(sensor_), CAVE_TRACKER_FRAME, ori.vec);
	setPosition(pos);
	setOrientation(ori);
	ygSimpleTransform::app();
	}
