#include <pfcave.h>
#include "ygCAVEWand.h"

extern "C" ygNode* construct_ygCAVEWand(const char* name,bool master) { return new ygCAVEWand(name,master); }

struct _ygCAVEWandPrivateData
	{
	int prevState[CAVE_MAX_BUTTONS];
	};


ygCAVEWand::ygCAVEWand(const char* name,bool master) : ygWand(name,master)
	{
	int i;
	setClassName("ygCAVEWand");
	p_ = new struct _ygCAVEWandPrivateData;
	for (i=0; i < CAVE_MAX_BUTTONS; i++)
		p_->prevState[i] = 0;
	}


void ygCAVEWand::reset(void)
	{
	int i;
	for (i=0; i < CAVE_MAX_BUTTONS; i++)
		p_->prevState[i] = 0;
	ygWand::reset();
	}


void ygCAVEWand::app(void)
	{
	int i;
	char flagName[16];
	for (i=0; i < CAVEController->num_buttons; i++)
		{
		if ((CAVEController->button[i]) && (!p_->prevState[i]))
			{
			sprintf(flagName,"button%d",i+1);
			setFlag(flagName);
			}
		p_->prevState[i] = CAVEController->button[i];
		}
	ygWand::app();
	}
