/*
 * Ygdrasil Version 0.1.5
 */
#ifndef _ygLight_h_
#define _ygLight_h_

#include <Performer/pr/pfLinMath.h>
#include "ygNode.h"


class ygLight : public ygNode
	{
	public:
	 ygLight(const char*,bool master=true);
	 virtual ~ygLight(void);
	 virtual void reset(void);
	 virtual void message(const ygMessage&);
	 virtual void app(void);
		 void on(void);
		 void off(void);
		 void toggle(void);
		 bool isOn(void) const;
		 void setPosition(float x,float y,float z,float w=0);
		 void setDiffuse(float r,float g,float b);
	 inline	 void setPosition(pfVec3 v) { setPosition(v[0],v[1],v[2],0); }
	 inline	 void setPosition(pfVec4 v) { setPosition(v[0],v[1],v[2],v[3]);}
	 inline	 void setDiffuse(pfVec3 v) { setDiffuse(v[0],v[1],v[2]); }
	protected:
	 virtual void acceptNetKey(const ygString&);
	private:
	 struct _ygLightPrivateData *p_;
		 void setPosition(const ygMessage&);
		 void setDiffuse(const ygMessage&);
	};


extern "C" ygNode* construct_ygLight(const char*,bool);

#endif
